﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.IO;

public partial class WebSiteDiretoryFileList : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            CreateFileList();
        }
    }

    private void CreateFileList()
    {
        string directory = Request.PhysicalApplicationPath;
        string[] fileList = Directory.GetFiles(directory);
        lstFiles.DataSource = fileList;
        lstFiles.DataBind();
        lblFileInfo.Text = "";
    }

    protected void lstFiles_SelectedIndexChanged(object sender, EventArgs e)
    {
        string fileName = lstFiles.SelectedItem.Text;
        System.Text.StringBuilder displayString = new System.Text.StringBuilder();
        displayString.Append("<b>");
        displayString.Append(fileName);
        displayString.Append("</b><br /><br />");
        displayString.Append("생성 시각 : ");
        displayString.Append(File.GetCreationTime(fileName).ToString());
        displayString.Append("<br />");
        displayString.Append("최종 접근 시각 : ");
        displayString.Append(File.GetLastAccessTime(fileName).ToString());
        displayString.Append("<br />");

        lblFileInfo.Text = displayString.ToString();
    }

    protected void btnRefresh_Click(object sender, EventArgs e)
    {
        CreateFileList();
    }
}
